# -*- coding: utf-8 -*-

import es
import random
import cPickle
from os.path import isfile
from gamethread import delayed
from popuplib import easymenu
from configobj import ConfigObj
from playerlib import getPlayer
from nativetools import spawnPlayer
from usermsg import showVGUIPanel

player = {}
sounds = ['hidden/617-radiotaunts08.mp3', 'hidden/617-radiotaunts01.mp3', 'hidden/617-radiotaunts06.mp3']
death_hidden = ['hidden/617-death01.mp3', 'hidden/617-death05.mp3']
death_iris = ['hidden/IRIS-death14.wav', 'hidden/IRIS-death04.wav']

class Configuration(object):
    def __init__(self):
        self.cfgfile = es.getAddonPath('hidden') + '/hidden_config.ini'
    def getFile(self):
        return ConfigObj(self.cfgfile)
config = Configuration()

class Player(object):
    def __init__(self, userid):
        self.userid = userid
        self._class = self.prim = self.sec = self.addition = self.class_time = self.adrenaline_reset = self.roundkills = 0
    def fire(self, cmd):
        es.server.queuecmd('es_xfire %s %s' % (self.userid, cmd))
    def give(self, cmd):
        es.server.queuecmd('es_xgive %s %s' % (self.userid, cmd))
    def strip(self):
        self.fire('player_weaponstrip kill')
        self.give('player_weaponstrip')
        self.fire('player_weaponstrip strip')
        delayed(0, self.give, 'item_assaultsuit')
        delayed(0, self.give, 'weapon_knife')
    def funcs(self, arg):
        arg = arg.capitalize()
        self.fire('func_buyzone %s' % arg)
        self.fire('func_bomb_target %s' % arg)
        self.fire('func_hostage_rescue %s' % arg)
    def _format(self, text, team):
        _s = 'ONE #greenHidden'
        count = int(config.getFile()['hidden']['count'])
        if count > 1:
            _s = '%s #greenHiddens' % count
        es.tell(self.userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultThere %s be #lightgreen%s#default!' % (text, _s))
        delayed(0, change_team, (self.userid, team))
    def spawn(self, team):
        player = getPlayer(self.userid)
        cfg = config.getFile()['hidden']
        self.funcs('disable')
        self.strip()
        es.setplayerprop(self.userid, 'CCSPlayer.baseclass.m_lifeState', 512)
        hiddens = int(cfg['count'])
        if team == 2:
            if es.getplayercount(2) > hiddens:
                self._format('can only', 3)
            elif es.getplayercount(2) == hiddens:
                health = int(cfg['health'])
                hp = health
                es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', health)
                es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', float(cfg['speed']))
                player.set('color', (255, 255, 255, 19))
                player.set('weaponcolor', (255, 255, 255, 0))
                if self.roundkills:
                    _s = '1 #greenIRIS Force'
                    if self.roundkills > 1:
                        _s = '%s #greenIRIS Forces' % self.roundkills
                    if self.roundkills == es.getplayercount(3):
                        hp = int(hp) + health
                    elif self.roundkills == es.getplayercount(3) / 2:
                        hp = int(hp) + health / 2
                    es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', hp)
                    es.tell(self.userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen%s#default.' % (hp, _s))
                    self.roundkills = 0
        elif team == 3:
            if es.getplayercount(2) < hiddens:
                self._format('must', 2)
            elif es.getplayercount(2) == hiddens:
                player.set('color', (255, 255, 255, 255))
                player.set('weaponcolor', (255, 255, 255, 255))
                es.tell(self.userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultType #lightgreen!class #defaultto change your class.')
                if es.getplayersteamid(self.userid) == 'BOT':
                    delayed(0, self.give, 'weapon_%s' % random.choice(config.getFile()['iris']['bot_sec']))
                    delayed(0, self.give, 'weapon_%s' % random.choice(config.getFile()['iris']['bot_prim']))
                else:
                    self.class_time = self.adrenaline_reset = 0
                    if self._class:
                        hp = 125
                        if self._class == 'assault':
                            hp = 50 if self.prim == 'm4a1' else 75
                        es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', hp)
                        if self.addition == 'nvgs' and int(config.getFile()['general']['dark_mode']):
                            delayed(.1, self.give, 'item_nvgs')
                            delayed(.1, es.setplayerprop, (self.userid, 'CCSPlayer.m_bNightVisionOn', 1))
                        delayed(.1, self.give, 'weapon_%s' % self.sec)
                        delayed(.1, self.give, 'weapon_%s' % self.prim)
                    else:
                        delayed(0, choose.send, self.userid)
    def death(self, attacker):
        uteam = es.getplayerteam(self.userid)
        ateam = es.getplayerteam(attacker)
        cfg = config.getFile()['hidden']
        if uteam == 2 and ateam == 3:
            es.cexec(self.userid, random.choice(death_hidden))
            hiddens = int(cfg['count'])
            delayed(0, change_team, (self.userid, 3))
            delayed(0, change_team, (attacker, 2))
            _s = 'the' if hiddens == 1 else 'a'
            es.msg('#multi', '#green[#lightgreenES Hidden#green] %s #defaultis now %s #greenHidden' % (es.getplayername(attacker), _s))
            if hiddens > 1:
                spawnPlayer(self.userid)
                spawnPlayer(attacker)
            else:
                es.cexec_all('play', 'hidden/IRIS-roundend06.wav')
        elif uteam == 3 and ateam == 2:
            add = int(cfg['additional_health'])
            speed = es.getplayerprop(attacker, 'CBasePlayer.localdata.m_flLaggedMovementValue')
            es.setplayerprop(attacker, 'CBasePlayer.localdata.m_flLaggedMovementValue', float(speed) + float(cfg['extra_speed']))
            es.setplayerprop(attacker, 'CBasePlayer.m_iHealth', int(es.getplayerprop(attacker, 'CBasePlayer.m_iHealth')) + add)
            es.setplayerprop(attacker, 'CBasePlayer.m_lifeState', 0)
            es.cexec_all('play', random.choice(sounds))
            es.cexec(self.userid, 'playgamesound', random.choice(death_iris))
            es.msg('#multi', '#green[#lightgreenES Hidden#green] Hidden #lightgreen%s #defaultgot #green%s #lightgreenHP #defaultfor killing #green%s' % (es.getplayername(attacker), add, es.getplayername(self.userid)))
            self.roundkills += 1
            delayed(2, es.setplayerprop, (attacker, 'CBasePlayer.m_lifeState', 512))
    def setCTime(self):
        self.class_time = 0
    def getClass(self):
        if es.getplayerteam(self.userid) == 3:
            _time = float(config.getFile()['iris']['class_time'])
            if not self.class_time:
                choose.send(self.userid)
                self.class_time = 1
                delayed(_time, self.setCTime)
            else:
                es.tell(self.userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou can only change your class within #lightgreen%s #defaultseconds!' % _time)
        else:
            es.tell(self.userid, '#multi', "#green[#lightgreenES Hidden#green] Hidden #lightgreencan't change its class!")
    def _choose(self, choice):
        self._class = choice
        if choice == 'assault':
            assault.send(self.userid)
        else:
            support.send(self.userid)
    def _assault(self, choice):
        self.prim = choice
        addition.send(self.userid)
    def _support(self, choice):
        self.prim = choice
        addition.send(self.userid)
    def _sec(self, choice):
        self.sec = choice
        self.strip()
        delayed(0, self.giveWeapons)
    def _addition(self, choice):
        self.addition = choice
        sec.send(self.userid)
    def giveWeapons(self):
        hp = 125
        if self._class == 'assault':
            hp = 50 if self.prim == 'm4a1' else 75
        es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', hp)
        self.give('weapon_%s' % self.sec)
        self.give('weapon_%s' % self.prim)
        self.give('item_%s' % self.addition)

def load():
    global choose, sec, support, assault, addition
    es.ServerVar('hidden_ver', '4.0 ESP').makepublic()
    es.ServerVar('mp_autoteambalance').set(0)
    es.ServerVar('mp_limitteam').set(0)
    choose = easymenu('hidden_choose_class', '_popup_choice', Choose)
    choose.settitle('Assault or Support?')
    choose.setdescription('Assault: Powerful Weapons, less HP\nSupport: Less powerful Weapons, more HP')
    choose.addoption('assault', '[√] Assault')
    choose.addoption('support', '[√] Support')
    assault = easymenu('hidden_assault', '_popup_choice', Assault)
    assault.setdescription('M4A1 Carbine will set your HP to 50...')
    assault.addoption('m4a1', '[√] FN4700 Assault Rifle (M4A1 Carbine)')
    assault.addoption('famas', '[√] FN2000 Assault Rifle (FAMAS)')
    assault.addoption('mp5navy', '[√] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    assault.addoption('m3', '[√] Remington 870 MCS Shotgun (M3)')
    assault.addoption('xm1014', '[√] FN303 Less Lethal Launcher (XM1014)')
    support = easymenu('hidden_support', '_popup_choice', Support)
    support.settitle('Support Menu')
    support.addoption('mp5navy', '[√] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    support.addoption('tmp', '[√] FN Tactial Machine Gun  (TMP)')
    support.addoption('xm1014', '[√] FN303 Less Lethal Launcher (XM1014)')
    sec = easymenu('hidden_secondary', '_popup_choice', Sec)
    sec.addoption('fiveseven', '[√] FN FiveSeven Pistol (Fiveseven)')
    sec.addoption('p228', '[√] FNP-9 Pistol (P228)')
    addition = easymenu('hidden_addition', '_popup_choice', Addition)
    addition.settitle('Choose an Additional')
    addition.addoption('nvgs', '[√] Light Amplification Goggles (NVGs)')
    for userid in es.getUseridList():
        uid = str(userid)
        player[uid] = Player(uid)
    if not es.exists('saycommand', '!class'):
        es.regsaycmd('!class', 'hidden/getclass')
    downloads()

def unload():
    choose.delete()
    sec.delete()
    assault.delete()
    support.delete()
    addition.delete()
    es.unregsaycmd('!class')
    for userid in player:
        player[userid].funcs('enable')
    player.clear()

def es_map_start(ev):
    downloads()

def downloads():
    for x in ('hidden/IRIS-roundend06.wav', 'hidden/IRIS-roundstart02.wav', 'hidden/617-radiotaunts08.mp3', 'hidden/617-radiotaunts01.mp3', 'hidden/617-radiotaunts06.mp3', 'hidden/617-death01.mp3', 'hidden/617-death05.mp3', 'hidden/IRIS-death14.wav', 'hidden/IRIS-death04.wav'):
        es.stringtable('downloadables', 'sound/%s' % x)

def change_team(userid, team):
    if not es.exists('userid', userid):
        return
    es.changeteam(userid, team)
    cID = random.randint(1, 4)
    if team == 2:
        es.setplayerprop(userid, 'CCSPlayer.m_iClass', cID)
        showVGUIPanel(userid, 'class_ter', False, {})
    elif team == 3:
        es.setplayerprop(userid, 'CCSPlayer.m_iClass', cID + 4)
        showVGUIPanel(userid, 'class_ct', False, {})

def getclass():
    player[str(es.getcmduserid())].getClass()

def Choose(userid, choice, popupid):
    player[str(userid)]._choose(choice)

def Assault(userid, choice, popupid):
    player[str(userid)]._assault(choice)

def Support(userid, choice, popupid):
    player[str(userid)]._support(choice)

def Sec(userid, choice, popupid):
    player[str(userid)]._sec(choice)

def Addition(userid, choice, popupid):
    player[str(userid)]._addition(choice)

def round_start(ev):
    es.msg('#multi', '#green[#lightgreenES Hidden#green] #lightgreen- #greenMISSION EXECUTE #lightgreen-')
    es.lightstyle(0, config.getFile()['general']['dark_mode'].replace('0', 'g').replace('1', 'b').replace('2', 'a'))
    for userid in es.getUseridList():
        if es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            spawnPlayer(userid)

def round_freeze_end(ev):
    es.cexec_all('play', 'hidden/IRIS-roundstart02.wav')
    for userid in es.getUseridList():
        if es.getplayerteam(userid) == 3:
            es.centertell(userid, '617 has been spotted in this sector - MOVE OUT!')
            delayed(1, es.centertell, (userid, '617 has been spotted in this sector - MOVE OUT!'))
            delayed(2, es.centertell, (userid, '617 has been spotted in this sector - MOVE OUT!'))
        elif es.getplayerteam(userid) == 2:
            es.centertell(userid, 'You are the Hidden - Rescue yourself!')
            delayed(1, es.centertell, (userid, 'You are the Hidden - Rescue yourself!'))
            delayed(2, es.centertell, (userid, 'You are the Hidden - Rescue yourself!'))

def player_activate(ev):
    userid = ev['userid']
    if not player.has_key(userid):
        player[userid] = Player(userid)

def player_spawn(ev):
    userid = ev['userid']
    team = int(ev['es_userteam'])
    if team > 1 and player.has_key(userid):
        player[userid].spawn(team)

def item_pickup(ev):
    userid = ev['userid']
    if ev['es_userteam'] == '2' and ev['item'] != 'knife' and player.has_key(userid):
        player[userid].strip()

def player_death(ev):
    player[ev['userid']].death(ev['attacker'])

def player_disconnect(ev):
    del player[ev['userid']]
